import * as v from 'valibot';
export * from 'valibot';
import { Resource } from './core';

export const datelike = () => v.transform(
	v.union([
		v.string([v.isoDate()]),
		v.string([v.isoDateTime()]),
		v.number(),
		v.date()
	]),
	(value) => new Date(value).toISOString(),
	v.string([v.isoTimestamp()])
);

export type ResourceType<R extends Resource> = v.Output<R['schema']>;

export type ResourceTypeWithId<R extends Resource> = ResourceType<R> & Record<R['state']['idAttr'], v.Output<R['state']['idConfig']['schema']>>;
